diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
index 442e7304a..e25b4302d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
@@ -6,27 +6,28 @@ import java.util.Random;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.MaterialColor;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
-public class BlockLogicStairs extends BlockLogic
-{
-//    private static final Map<Integer, BoundingVolume> selectionVolumes = new HashMap<>();
+public class BlockLogicStairs extends BlockLogic {
+    //    private static final Map<Integer, BoundingVolume> selectionVolumes = new HashMap<>();
 //
 //    static
 //    {
@@ -172,9 +173,8 @@ public class BlockLogicStairs extends BlockLogic
 
     public @NotNull Block<?> modelBlock;
 
-	public BlockLogicStairs(@NotNull Block<?> block, @NotNull Block<?> modelBlock)
-    {
-        super(block, Material.stone);
+    public BlockLogicStairs(@NotNull Block<?> block, @NotNull Block<?> modelBlock) {
+        super(block, Materials.STONE);
         this.modelBlock = modelBlock;
         block.withLightBlock(255);
     }
@@ -191,24 +191,22 @@ public class BlockLogicStairs extends BlockLogic
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    public boolean canPlaceOnSurfaceOnCondition(@NotNull World world, @NotNull TilePos tilePos) {
-    	return (world.getBlockData(tilePos) & MASK_ROTATION_VERTICAL) != 0;
+    public boolean canPlaceOnSurfaceOnCondition(@NotNull World world, @NotNull TilePosc tilePos) {
+        return (world.getBlockData(tilePos) & MASK_ROTATION_VERTICAL) != 0;
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         int meta = world.getBlockData(tilePos);
         int hRot = meta & MASK_ROTATION_HORIZONTAL;
         if ((meta & MASK_ROTATION_VERTICAL) != 0) {
@@ -219,7 +217,7 @@ public class BlockLogicStairs extends BlockLogic
     }
 
     @Override
-    public void getCollisionAABBs(@NotNull World world, @NotNull TilePos tilePos, @NotNull AABB aabb, @NotNull List<@NotNull AABB> aabbList) {
+    public void getCollisionAABBs(@NotNull World world, @NotNull TilePosc tilePos, @NotNull AABBdc aabb, @NotNull List<@NotNull AABBdc> aabbList) {
         int meta = world.getBlockData(tilePos);
         int hRotation = meta & MASK_ROTATION_HORIZONTAL;
         int vRotation = meta & MASK_ROTATION_VERTICAL;
@@ -228,34 +226,31 @@ public class BlockLogicStairs extends BlockLogic
 
         switch (hRotation) {
             case H_ROTATION_WEST:
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F + stepYOffset, 0.0F, 0.5F, 0.5F + stepYOffset, 1.0F).move(tilePos), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.5F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F).move(tilePos), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F + stepYOffset, 0.0F, 0.5F, 0.5F + stepYOffset, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.5F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
                 break;
             case H_ROTATION_EAST:
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 0.0F, 0.5F, 1.0F, 1.0F).move(tilePos), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.5F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 1.0F).move(tilePos), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F, 0.0F, 0.5F, 1.0F, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.5F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
                 break;
             case H_ROTATION_NORTH:
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 0.5F).move(tilePos), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 0.5F, 1.0F, 1.0F, 1.0F).move(tilePos), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 0.5F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F, 0.5F, 1.0F, 1.0F, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
                 break;
             case H_ROTATION_SOUTH:
             default:
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.5F).move(tilePos), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F + stepYOffset, 0.5F, 1.0F, 0.5F + stepYOffset, 1.0F).move(tilePos), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.5F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
+                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F + stepYOffset, 0.5F, 1.0F, 0.5F + stepYOffset, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
                 break;
         }
     }
 
     @Override
-    public ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity)
-    {
-        final ItemStack @Nullable [] result = dropCause != EnumDropCause.IMPROPER_TOOL ? new ItemStack[] { new ItemStack(this.block) } : null;
-
-        if (result != null)
-        {
-            for (ItemStack stack : result)
-            {
+    public ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
+        final ItemStack @Nullable [] result = dropCause != EnumDropCause.IMPROPER_TOOL ? new ItemStack[]{new ItemStack(this.block)} : null;
+
+        if (result != null) {
+            for (ItemStack stack : result) {
                 stack.setMetadata(data & 0xF0);
                 stack.itemID = this.id();
             }
@@ -265,25 +260,22 @@ public class BlockLogicStairs extends BlockLogic
     }
 
     @Override
-    public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand) {
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
         this.modelBlock.animationTick(world, tilePos, rand);
     }
 
     @Override
-    public float getBrightness(@NotNull WorldSource source, @NotNull TilePos tilePos)
-    {
+    public float getBrightness(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return this.modelBlock.getBrightness(source, tilePos);
     }
 
     @Override
-    public float getBlastResistance(Entity entity)
-    {
+    public float getBlastResistance(Entity entity) {
         return this.modelBlock.getBlastResistance(entity);
     }
 
     @Override
-    public int tickDelay()
-    {
+    public int tickDelay() {
         return this.modelBlock.tickDelay();
     }
 //    @Override
@@ -294,70 +286,65 @@ public class BlockLogicStairs extends BlockLogic
 //    }
 
     @Override
-    public void onEntityInside(@NotNull World world, @NotNull TilePos tilePos, @NotNull Entity entity, @NotNull Vec3 velocity) {
-        this.modelBlock.onEntityInside(world, tilePos, entity, velocity);
+    public void onEntityInside(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity, @NotNull Vector3d velocityDirection) {
+        this.modelBlock.onEntityInside(world, tilePos, entity, velocityDirection);
     }
 
     @Override
-    public boolean isCollidable()
-    {
+    public boolean isCollidable() {
         return this.modelBlock.isCollidable();
     }
 
     @Override
-    public boolean canCollideCheck(int data, boolean shouldCollideWithFluids)
-    {
+    public boolean canCollideCheck(int data, boolean shouldCollideWithFluids) {
         return this.modelBlock.canCollideCheck(data, shouldCollideWithFluids);
     }
 
     @Override
-	public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         return this.modelBlock.canPlaceAt(world, tilePos);
     }
 
     @Override
-	public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         onNeighborChanged(world, tilePos, 0);
         this.modelBlock.onPlacedByWorld(world, tilePos);
     }
 
     @Override
-    public void onEntityWalkedOn(@NotNull World world, @NotNull TilePos tilePos, @NotNull Entity walker) {
+    public void onEntityWalkedOn(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity walker) {
         this.modelBlock.onEntityWalkedOn(world, tilePos, walker);
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick)
-    {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         this.modelBlock.updateTick(world, tilePos, rand, false);
     }
 
     @Override
-    public void onAttacked(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
+    public void onAttacked(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
         this.modelBlock.onAttacked(world, tilePos, player, side, xHit, yHit);
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         return this.modelBlock.onInteracted(world, tilePos, player, side, xHit, yHit);
     }
 
     @Override
-    public void onDestroyedByExplosion(@NotNull World world, @NotNull TilePos tilePos) {
+    public void onDestroyedByExplosion(@NotNull World world, @NotNull TilePosc tilePos) {
         this.modelBlock.onDestroyedByExplosion(world, tilePos);
     }
 
     @Override
-    public void onPlacedByMob(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, Mob mob, double xHit, double yHit) {
+    public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
         int meta = world.getBlockData(tilePos) & 0xF0;
 
         Direction hRotation = mob.getHorizontalPlacementDirection(side).getOpposite();
-        if(hRotation == Direction.NORTH) meta |= H_ROTATION_NORTH;
-        if(hRotation == Direction.EAST) meta |= H_ROTATION_EAST;
-        if(hRotation == Direction.SOUTH) meta |= H_ROTATION_SOUTH;
-        if(hRotation == Direction.WEST) meta |= H_ROTATION_WEST;
+        if (hRotation == Direction.NORTH) meta |= H_ROTATION_NORTH;
+        if (hRotation == Direction.EAST) meta |= H_ROTATION_EAST;
+        if (hRotation == Direction.SOUTH) meta |= H_ROTATION_SOUTH;
+        if (hRotation == Direction.WEST) meta |= H_ROTATION_WEST;
 
         Direction vRotation = mob.getVerticalPlacementDirection(side, yHit);
 //        if (vRotation == Direction.DOWN) meta |= 0b0000;
@@ -367,16 +354,16 @@ public class BlockLogicStairs extends BlockLogic
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         int meta = world.getBlockData(tilePos) & 0xF0;
 
         side = side.getOpposite();
         Side hSide = !side.isHorizontal() ? Side.NORTH : side;
         Direction hRotation = hSide.getOpposite().getDirection();
-        if(hRotation == Direction.NORTH) meta |= H_ROTATION_NORTH;
-        if(hRotation == Direction.EAST) meta |= H_ROTATION_EAST;
-        if(hRotation == Direction.SOUTH) meta |= H_ROTATION_SOUTH;
-        if(hRotation == Direction.WEST) meta |= H_ROTATION_WEST;
+        if (hRotation == Direction.NORTH) meta |= H_ROTATION_NORTH;
+        if (hRotation == Direction.EAST) meta |= H_ROTATION_EAST;
+        if (hRotation == Direction.SOUTH) meta |= H_ROTATION_SOUTH;
+        if (hRotation == Direction.WEST) meta |= H_ROTATION_WEST;
 
         Side vSide = !side.isVertical() ? Side.BOTTOM : side;
         Direction vRotation = vSide.getDirection();
@@ -387,11 +374,12 @@ public class BlockLogicStairs extends BlockLogic
     }
 
     @Override
-    public float getAmbientOcclusionStrength(@NotNull WorldSource source, @NotNull TilePos tilePos) {
-    	return 0.0f;
+    public float getAmbientOcclusionStrength(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        return 0.0f;
     }
+
     @Override
-    public @NotNull MaterialColor getMaterialColor(){
+    public @NotNull MaterialColor getMaterialColor() {
         return this.modelBlock.getMaterialColor();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPaintable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPaintable.java
index 90039bb3c..f6ee94654 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPaintable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPaintable.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicStairsPaintable extends BlockLogicStairs implements IPaintable {
@@ -11,7 +11,7 @@ public class BlockLogicStairsPaintable extends BlockLogicStairs implements IPain
     }
 
     @Override
-    public void setColor(@NotNull World world, @NotNull TilePos tilePos, @NotNull DyeColor color) {
+    public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         final int meta = world.getBlockData(tilePos);
         world.setBlockIdDataNotify(tilePos, Blocks.STAIRS_PLANKS_PAINTED.id(), meta);
         Blocks.STAIRS_PLANKS_PAINTED.getLogic().setColor(world, tilePos, color);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPainted.java
index a6d68e223..dc039ffc1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPainted.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicStairsPainted extends BlockLogicStairs implements IPainted {
@@ -26,13 +26,13 @@ public class BlockLogicStairsPainted extends BlockLogicStairs implements IPainte
     }
 
     @Override
-    public void removeDye(@NotNull World world, @NotNull TilePos tilePos) {
+    public void removeDye(@NotNull World world, @NotNull TilePosc tilePos) {
         final int meta = world.getBlockData(tilePos);
         world.setBlockIdDataNotify(tilePos, Blocks.STAIRS_PLANKS_OAK.id(), stripColorFromMetadata(meta));
     }
 
     @Override
-    public void setColor(@NotNull World world, @NotNull TilePos tilePos, @NotNull DyeColor color) {
+    public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         IPainted.super.setColor(world, tilePos, color);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStalk.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStalk.java
index d84d6431a..581546f23 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStalk.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStalk.java
@@ -1,28 +1,28 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.ISupportable;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
 public class BlockLogicStalk extends BlockLogic implements ISupportable {
     public BlockLogicStalk(@NotNull Block<?> block) {
-        super(block, Material.plant);
+        super(block, Materials.PLANT);
         block.setTicking(true);
         float offset = 0.2F;
         setBlockBounds(0.5F - offset, 0.0F, 0.5F - offset, 0.5F + offset, offset * 3F, 0.5F + offset);
     }
 
     @Override
-    public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos) {
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         return super.canPlaceAt(world, tilePos) && canStay(world, tilePos);
     }
 
@@ -37,24 +37,24 @@ public class BlockLogicStalk extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return null;
     }
 
     @Override
-    public boolean canStay(@NotNull World world, @NotNull TilePos tilePos)
+    public boolean canStay(@NotNull World world, @NotNull TilePosc tilePos)
     {
         return isSupported(world, tilePos, Side.BOTTOM);
     }
 
 
     @Override
-    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return FullSupport.INSTANCE;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
index 4a337437e..4e1953668 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
@@ -15,6 +15,7 @@ import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -43,7 +44,7 @@ public class BlockLogicStatue extends BlockLogic {
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         final @Nullable TileEntityStatue statueEntity = getTileEntity(world, tilePos);
         if (statueEntity == null) {
             return false;
@@ -52,7 +53,7 @@ public class BlockLogicStatue extends BlockLogic {
         // Sneaking overrides all - next pose
         if (player.isSneaking()) {
             statueEntity.nextPose();
-            world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) tilePos.x + 0.5D, (double) tilePos.y + 0.5D, (double) tilePos.z + 0.5D, "random.scrape", 0.7F, 0.2F + world.rand.nextFloat() * 0.4F);
+            world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "random.scrape", 0.7F, 0.2F + world.rand.nextFloat() * 0.4F);
             return true;
         }
 
@@ -144,7 +145,7 @@ public class BlockLogicStatue extends BlockLogic {
 
         // All else fails - next pose
         statueEntity.nextPose();
-        world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) tilePos.x + 0.5D, (double) tilePos.y + 0.5D, (double) tilePos.z + 0.5D, "random.scrape", 0.7F, 0.2F + world.rand.nextFloat() * 0.2F);
+        world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "random.scrape", 0.7F, 0.2F + world.rand.nextFloat() * 0.2F);
         return true;
     }
 
@@ -159,12 +160,12 @@ public class BlockLogicStatue extends BlockLogic {
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
-    public @Nullable TileEntityStatue getTileEntity(final @NotNull World world, final @NotNull TilePos tilePos) {
-        TilePos entPos = this.isBottom ? tilePos : tilePos.down();
+    public @Nullable TileEntityStatue getTileEntity(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        TilePosc entPos = this.isBottom ? tilePos : tilePos.down(new TilePos());
         final @Nullable Block<?> block = world.getBlock(entPos);
         if (block == null || !(block.getLogic() instanceof BlockLogicStatue)) {
             return null;
@@ -179,7 +180,7 @@ public class BlockLogicStatue extends BlockLogic {
     }
 
     @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePos tilePos, int data) {
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         if (this.isBottom) {
             List<ItemStack> stacks = new ArrayList<>();
             final @Nullable TileEntity tileEntity = world.getTileEntity(tilePos);
@@ -204,12 +205,12 @@ public class BlockLogicStatue extends BlockLogic {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         final Block<?> otherBlock;
         if (!this.isBottom) {
-            otherBlock = world.getBlock(tilePos.down());
+            otherBlock = world.getBlock(tilePos.down(new TilePos()));
         } else {
-            otherBlock = world.getBlock(tilePos.up());
+            otherBlock = world.getBlock(tilePos.up(new TilePos()));
         }
         if (!(otherBlock != null && otherBlock.getLogic() instanceof BlockLogicStatue)) {
             world.setBlockIdNotify(tilePos, 0);
@@ -217,26 +218,26 @@ public class BlockLogicStatue extends BlockLogic {
     }
 
     @Override
-    public @NotNull ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, @NotNull TilePos tilePos, int data, @Nullable TileEntity tileEntity) {
+    public @NotNull ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, @NotNull TilePosc tilePos, int data, @Nullable TileEntity tileEntity) {
         if (this.droppedItem == null) return null;
         if (dropCause != EnumDropCause.IMPROPER_TOOL) {
-            return new ItemStack[] { new ItemStack(this.droppedItem.get()) };
+            return new ItemStack[]{new ItemStack(this.droppedItem.get())};
         }
 
         return null;
     }
 
     @Override
-    public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos) {
-        if (tilePos.y >= world.getHeightBlocks() - 1) {
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
+        if (tilePos.y() >= world.getHeightBlocks() - 1) {
             return false;
         } else {
-            return super.canPlaceAt(world, tilePos) && super.canPlaceAt(world, tilePos.up());
+            return super.canPlaceAt(world, tilePos) && super.canPlaceAt(world, tilePos.up(new TilePos()));
         }
     }
 
     @Override
-    public int getPistonPushReaction(@NotNull World world, @NotNull TilePos tilePos) {
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStone.java
index 11c51e674..49b6c6f1b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStone.java
@@ -10,6 +10,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -17,45 +18,43 @@ import java.util.Random;
 
 public class BlockLogicStone extends BlockLogic {
 
-	private final @NotNull Block<?> cobble;
-
-	public BlockLogicStone(@NotNull Block<?> block, @NotNull Block<?> cobbleStone, @NotNull Material material) {
-		super(block, material);
-		this.cobble = cobbleStone;
-	}
-
-	@Override
-	public void onHarvest(@NotNull World world, @NotNull Player player, @NotNull TilePos tilePos, int data, @Nullable TileEntity tileEntity)
-	{
-		super.onHarvest(world, player, tilePos, data, tileEntity);
-		if(
-			player.getStat(Blocks.STONE.getStat(StatList.STAT_MINED)) > 0 &&
-			player.getStat(Blocks.BASALT.getStat(StatList.STAT_MINED)) > 0 &&
-			player.getStat(Blocks.GRANITE.getStat(StatList.STAT_MINED)) > 0 &&
-			player.getStat(Blocks.LIMESTONE.getStat(StatList.STAT_MINED)) > 0 &&
-			player.getStat(Blocks.PERMAFROST.getStat(StatList.STAT_MINED)) > 0) {
-
-			player.triggerAchievement(Achievements.COLLECT_STONE);
-		}
-	}
-
-	@Override
-	public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand) {
-
-        Chunk chunk = world.getChunk(tilePos.toChunkPos());
-		if (tilePos.y <= 32 && chunk.getChunkRandom(0x3ad8025fL).nextInt(10) == 0 && world.getBlockId(tilePos.down()) == 0) {
-			if (rand.nextInt(50) == 0)
-				world.spawnParticle("slimechunk", tilePos.x, tilePos.y, tilePos.z, 0.0D, 0.0D, 0.0D, 0);
-		}
-	}
-
-	@Override
-	public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity)
-	{
+    private final @NotNull Block<?> cobble;
+
+    public BlockLogicStone(@NotNull Block<?> block, @NotNull Block<?> cobbleStone, @NotNull Material material) {
+        super(block, material);
+        this.cobble = cobbleStone;
+    }
+
+    @Override
+    public void onHarvest(@NotNull World world, @NotNull Player player, @NotNull TilePosc tilePos, int data, @Nullable TileEntity tileEntity) {
+        super.onHarvest(world, player, tilePos, data, tileEntity);
+        if (
+            player.getStat(Blocks.STONE.getStat(StatList.STAT_MINED)) > 0 &&
+                player.getStat(Blocks.BASALT.getStat(StatList.STAT_MINED)) > 0 &&
+                player.getStat(Blocks.GRANITE.getStat(StatList.STAT_MINED)) > 0 &&
+                player.getStat(Blocks.LIMESTONE.getStat(StatList.STAT_MINED)) > 0 &&
+                player.getStat(Blocks.PERMAFROST.getStat(StatList.STAT_MINED)) > 0) {
+
+            player.triggerAchievement(Achievements.COLLECT_STONE);
+        }
+    }
+
+    @Override
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+
+        Chunk chunk = world.getChunk(tilePos);
+        if (tilePos.y() <= 32 && chunk.getChunkRandom(0x3ad8025fL).nextInt(10) == 0 && world.getBlockId(tilePos.down(new TilePos())) == 0) {
+            if (rand.nextInt(50) == 0)
+                world.spawnParticle("slimechunk", tilePos.x(), tilePos.y(), tilePos.z(), 0.0D, 0.0D, 0.0D, 0);
+        }
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
         return switch (dropCause) {
-            case PISTON_CRUSH, WORLD, EXPLOSION, PROPER_TOOL -> new ItemStack[]{new ItemStack(cobble)};
+            case PISTON_CRUSH, WORLD, EXPLOSION, PROPER_TOOL -> new ItemStack[]{new ItemStack(this.cobble)};
             case PICK_BLOCK, SILK_TOUCH -> new ItemStack[]{new ItemStack(this)};
             default -> null;
         };
-	}
+    }
 }
